
u32 ft_AlphaFunc(u8 func, u8 ref)
{
  return (9UL << 24) | ((func & 7L) << 8) | ((ref & 255L) << 0);
}

u32 ft_Begin(u8 prim)
{
  return (31UL << 24) | prim;
}

u32 ft_BitmapHandle(u8 handle)
{
  return (5UL << 24) | handle;
}

u32 ft_BitmapLayout(u8 format, u16 linestride, u16 height)
{
  return (7UL << 24) | ((format & 31L) << 19) | ((linestride & 1023L) << 9) | ((height & 511L) << 0);
}

u32 ft_BitmapLayoutH(u8 linestride, u8 height)
{
  return (0x28UL << 24) | ((linestride & 3L) << 2) | ((height & 3L) << 0);
}

u32 ft_BitmapLayoutX(u16 linestride, u16 height)
{
  return (0x28UL << 24) | (((linestride >> 10) & 3L) << 2) | (((height >> 9) & 3L) << 0);
}

u32 ft_BitmapSize(u8 filter, u8 wrapx, u8 wrapy, u16 width, u16 height)
{
  u8 fxy = (filter << 2) | (wrapx << 1) | (wrapy);
  return (8UL << 24) | ((u32)fxy << 18) | ((width & 511L) << 9) | ((height & 511L) << 0);
}

u32 ft_BitmapSizeH(u8 width, u8 height)
{
  return (0x29UL << 24) | ((width & 3L) << 2) | ((height & 3L) << 0);
}

u32 ft_BitmapSizeX(u16 width, u16 height)
{
  return (0x29UL << 24) | (((width >> 9) & 3L) << 2) | (((height >> 9) & 3L) << 0);
}

u32 ft_BitmapSource(u32 addr)
{
  return (1UL << 24) | ((addr & 0x3FFFFFL) << 0);
}

u32 ft_BitmapTransformA(s32 a)
{
  return (21UL << 24) | ((a & 131071L) << 0);
}

u32 ft_BitmapTransformB(s32 b)
{
  return (22UL << 24) | ((b & 131071L) << 0);
}

u32 ft_BitmapTransformC(s32 c)
{
  return (23UL << 24) | ((c & 16777215L) << 0);
}

u32 ft_BitmapTransformD(s32 d)
{
  return (24UL << 24) | ((d & 131071L) << 0);
}

u32 ft_BitmapTransformE(s32 e)
{
  return (25UL << 24) | ((e & 131071L) << 0);
}

u32 ft_BitmapTransformF(s32 f)
{
  return (26UL << 24) | ((f & 16777215L) << 0);
}

u32 ft_BlendFunc(u8 src, u8 dst)
{
  return (11UL << 24) | ((src & 7L) << 3) | ((dst & 7L) << 0);
}

u32 ft_Call(u16 dest)
{
  return (29UL << 24) | ((dest & 2047L) << 0);
}

u32 ft_Cell(u8 cell)
{
  return (6UL << 24) | ((cell & 127L) << 0);
}

u32 ft_ClearColorA(u8 alpha)
{
  return (15UL << 24) | ((alpha & 255L) << 0);
}

u32 ft_ClearColorRGB(u8 red, u8 green, u8 blue)
{
  return (2UL << 24) | ((red & 255L) << 16) | ((green & 255L) << 8) | ((blue & 255L) << 0);
}

u32 ft_ClearColorRGB32(u32 rgb)
{
  return (2UL << 24) | (rgb & 0xffffffL);
}

u32 ft_Clear(u8 c, u8 s, u8 t)
{
  u8 m = (c << 2) | (s << 1) | t;
  return (38UL << 24) | m;
}

u32 ft_ClearAll()
{
  return (38UL << 24) | 7;
}

u32 ft_ClearStencil(u8 s)
{
  return (17UL << 24) | ((s & 255L) << 0);
}

u32 ft_ClearTag(u8 s)
{
  return (18UL << 24) | ((s & 255L) << 0);
}

u32 ft_ColorA(u8 alpha)
{
  return (16UL << 24) | ((alpha & 255L) << 0);
}

u32 ft_ColorMask(u8 r, u8 g, u8 b, u8 a)
{
  return (32UL << 24) | ((r & 1L) << 3) | ((g & 1L) << 2) | ((b & 1L) << 1) | ((a & 1L) << 0);
}

u32 ft_ColorRGB(u8 red, u8 green, u8 blue)
{
  return (4UL << 24) | ((red & 255L) << 16) | ((green & 255L) << 8) | ((blue & 255L) << 0);
}

u32 ft_ColorRGB32(u32 rgb)
{
  return (4UL << 24) | (rgb & 0xffffffL);
}

u32 ft_Display(void)
{
  return 0UL << 24;
}

u32 ft_End(void)
{
  return 33UL << 24;
}

u32 ft_Jump(u16 dest)
{
  return (30UL << 24) | ((dest & 2047L) << 0);
}

u32 ft_LineWidth(u16 width)
{
  return (14UL << 24) | ((width & 4095L) << 0);
}

u32 ft_Macro(u8 m)
{
  return (37UL << 24) | ((m & 1L) << 0);
}

u32 ft_PaletteSource(u32 addr)
{
  return (0x2AUL << 24) | ((addr & 0x3FFFFFL) << 0);
}

u32 ft_PointSize(u16 size)
{
  return (13UL << 24) | ((size & 8191L) << 0);
}

u32 ft_RestoreContext(void)
{
  return 35UL << 24;
}

u32 ft_Return(void)
{
  return 36UL << 24;
}

u32 ft_SaveContext(void)
{
  return 34UL << 24;
}

u32 ft_ScissorSize(u16 width, u16 height)
{
  return (28UL << 24) | ((width & 1023L) << 10) | ((height & 1023L) << 0);
}

u32 ft_ScissorXY(u16 x, u16 y)
{
  return (27UL << 24) | ((x & 511L) << 9) | ((y & 511L) << 0);
}

u32 ft_StencilFunc(u8 func, u8 ref, u8 mask)
{
  return (10UL << 24) | ((func & 7L) << 16) | ((ref & 255L) << 8) | ((mask & 255L) << 0);
}

u32 ft_StencilMask(u8 mask)
{
  return (19UL << 24) | ((mask & 255L) << 0);
}

u32 ft_StencilOp(u8 sfail, u8 spass)
{
  return (12UL << 24) | ((sfail & 7L) << 3) | ((spass & 7L) << 0);
}

u32 ft_TagMask(u8 mask)
{
  return (20UL << 24) | ((mask & 1L) << 0);
}

u32 ft_Tag(u8 s)
{
  return (3UL << 24) | s;
}

u32 ft_Vertex2f(s16 x, s16 y)
{
  return (1UL << 30) | ((x & 32767L) << 15) | ((y & 32767L) << 0);
}

u32 ft_Vertex2ii(u16 x, u16 y, u8 handle, u8 cell)
{
  return (2UL << 30) | ((x & 511L) << 21) | ((y & 511L) << 12) | ((handle & 31L) << 7) | ((cell & 127L) << 0);
}

u32 ft_VertexFormat(u8 f)
{
  return (0x27UL << 24) | (f & 7L);
}

u32 ft_VertexTranslateX(s32 v)
{
  return (0x2BUL << 24) | ((u32)v & 0x1FFFF);
}

u32 ft_VertexTranslateY(s32 v)
{
  return (0x2CUL << 24) | ((u32)v & 0x1FFFF);
}
